import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;
import org.apache.poi.xssf.usermodel.XSSFSheet;
import org.apache.poi.xssf.usermodel.helpers.ColumnHelper;
import java.io.FileOutputStream;
import java.lang.reflect.Field;

class Bug47581
{
  Sheet sh;
  Row row;
  boolean useWorkaround;
  
  public static void main(String[] args)
  {
    try {
      new Bug47581(args).run();
    }
    catch(Throwable e) {
      e.printStackTrace();
    }
  }
  
  Bug47581(String[] args)
  {
    useWorkaround = args.length > 0 && args[0].equals("help");
  }
  
  void run() throws Exception
  {
    XSSFWorkbook wb = new XSSFWorkbook();
    sh = wb.createSheet();
    setWidth(0, 5);  //5-character wide
    setWidth(1, 20); //20-character wide
    setWidth(2, 50); //50-character wide
  	row = sh.createRow(0);
  	addCell(0, "abcde");
  	addCell(1, "abcdefghijklmnopqrstuv");
  	addCell(2, "Wide cell. Should hold up to fifty characters.");
  	addCell(3, "Last one");

    String fn = "bug-47581-" + (useWorkaround ? "good" : "bad") + ".xlsx";
    FileOutputStream out = new FileOutputStream(fn);
    wb.write(out);
    out.close();
  }

  void addCell(int colNum, String text)
  {
  	Cell cell = row.createCell(colNum);
  	cell.setCellValue(text);
  }

  void setWidth(int colNum, int width) throws Exception
  {
	  sh.setColumnWidth(colNum, 256*width);
	  if (useWorkaround) {
	    Field f = sh.getClass().getDeclaredField("columnHelper");
	    f.setAccessible(true);
	    ColumnHelper ch = (ColumnHelper)f.get(sh);
	    ch.setCustomWidth(colNum, true);
	  }
  }
}